import { AppProps } from 'next/app';
import { GetServerSideProps } from 'next';
import { ApolloClient, NormalizedCacheObject } from '@apollo/client';
import { ApolloClientConfig, GetServerSideApolloPropsOptions, QueryHydrationMap } from './types';
export declare let __APOLLO_CLIENT__: ApolloClient<NormalizedCacheObject> | undefined;
export interface NextApolloClientOptions {
    client: ApolloClientConfig;
    hydrationMap?: QueryHydrationMap;
}
export declare class NextApolloClient<THydrationMap extends QueryHydrationMap> {
    private readonly _client;
    private readonly _hydrationMap?;
    constructor({ client, hydrationMap }: NextApolloClientOptions);
    private createApolloClient;
    private initializeApollo;
    private addApolloState;
    useApolloClient: (pageProps: AppProps['pageProps']) => ApolloClient<NormalizedCacheObject>;
    getServerSideApolloProps: <TProps = Record<string, any>>({ hydrateQueries, onClientInitialized, onHydrationComplete, }?: GetServerSideApolloPropsOptions<TProps, (keyof THydrationMap)[], THydrationMap>) => GetServerSideProps;
}
